 	
void mcp3421_init (int conversionmode, int conversionstartence, int bits, int gain)
{
	int string[8] config;	
	i2c_start_wait(MCP3421+I2C_WRITE);
	
	if (conversionstartence = CONVERSIONSTART)
	{
		config.0 = 1;
	}
	else
	{
		config.0 =0; //no conversionstart
	}	
	
	config.1 =0; //-\
	config.2 =0; // |>have no effect
	config.3 =0; //_/
	
	//conversion mode
	if (conversionmode == ContinuosConversion)
	{
		config.4 = 1;
	}
	else
	{
		config.4 = 0;
	}
	
	//accuracy
	if ( bits == twelve_bits)
	{
		config.5 = 0;
		config.6 = 0;
	}
	if ( bits == fourteen_bits)
	{
		config.5 = 0;
		config.6 = 1;
	} 
	if ( bits == sixteen_bits)
	{
		config.5 = 1;
		config.6 = 0;
	}
	if ( bits == eightteen_bits)
	{
		config.5 = 1;
		config.6 = 1;
	}
	
	//pga
	if (gain == PGAx1)
	{
		config.7 = 0;
		config.8 = 0;
	}
	if (gain == PGAx2)
	{
		config.7 = 0;
		config.8 = 1;
	}
	if (gain == PGAx4)
	{
		config.7 = 1;
		config.8 = 0;
	}
	if (gain == PGAx8)
	{
		config.7 = 1;
		config.8 = 1;
	}
		
	i2c_write(config);	
}

int read_mcp3421_adc_raw (void)
{
	int datastack;
	
	int data_udb; //upper  data byte
	int data_mdb; //middle   -"-
	int data_ldb; //lower    -"-
	int data_com; //complete data
	
	i2c_start(MCP3421+I2C_READ);
	
	mcp3421_init (OneShotConversion, CONVERSIONSTART, eightteen_bits, PGAx1);
	
	do 
	{
		i2c_rep_start(MCP3421+I2C_READ);
		
		datastack = i2c_readNak();
	}
	while (datastack <128)
	
	if ( datastack > 127)
	{
		i2c_rep_start(MCP3421+I2C_READ);
		
		int data_udb = i2c_readAck();
		int data_mdb = i2c_readAck();
		int data_ldb = i2c_readNak();
	}
	
	if ( data_udb >4)
	{
		data_udb = 4;
	}
	
	data_udb = data_udb^15 //shifting to real value
	data_mdb = data_mdb^7  // -"-
	data_ldb =  data_ldb^1 // -"-
	
	data_com = data_udb + data_mdb + data_ldb; //setting together
	
	return data_com;
}

float read_mcp3421_adc (int bits)
{
	volatile signed int data_adc;
	volatile signed float readenvoltage;
	volatile unsigned float onebitvoltage;
	
	data_adc = read_mcp3421_adc_raw();
	
	/**********************conversion into voltage***************************/
	/*					 vref                                               */
	/*	U(eingelesen)=	----------- * adresult								*/
	/*					 2^bitzahl											*/
	/*																		*/
	/*	 vref     4,096V     4,096V											*/
	/* --------= --------= ----------=  0,000015625V						*/
	/*  2^bits     2^18      262144											*/
	/************************************************************************/
	
	onebitvoltage = 4,096 / 2^bits;
	
	readenvoltage = onebitvoltage * data_adc;
	
	return readenvoltage;
}